((window, chrome, console) => {
    var selectedRange = null;
    var popupContainer = null;
    var highlightSpan = null;
    var nowPopupIsVisible = false;
    var buttonSeperator = null;
    var selectedText = '';
    var leftPosition = 0;
    var topPosition = 0;
    var displayText = 'Highlight';
    var editSpan = null;
    var mouseStart = null;
    var mouseEnd = null;
    var isDrag = false;
    var clientUrl = "config.client_url";
    var isUserLoggedIn = false;
    var originList = ["https://medium.com", "https://medium"];
    var highlightIdInUrl = __getUrlParmValue("lphiltid");

    var __processSelectedText = (event) => {
        //isDrag ? console.log("drag") : console.log("clicked");
        if (__highlightShouldEnable(event) && isDrag) {
            mouseEnd = event;
            leftMousePosition = event.pageX;
            if (mouseStart) {
                topPosition = mouseStart.pageY;
            } else {
                topPosition = event.pageY;
            }

            selectedRange = __getSelectedRange();

            if (selectedRange && selectedText && selectedText != '' && selectedRange != '') {
                nowPopupIsVisible = false;
                __highlightSelectedText(selectedRange);
            }
        } else {
            //selectedText = '';
            popupContainer.style.display = "none";
            //__deselect();
        }
    };

    var __getSelectedRange = () => {
        try {
            if (window.getSelection) {
                if (window.getSelection().toString()) {
                    selectedText = window.getSelection().toString();
                }
                selectedRange = window.getSelection().getRangeAt(0);
            } else {
                if (document.selection.createrange().text) {
                    selectedText = document.selection.createrange().text;
                }

                selectedRange = document.getSelection().getRangeAt(0);
            }
        } catch (err) {
            // console.log(err);
        }
        return selectedRange;
    };

    function __getHighLightSpan(id, cssClass) {
        var span = document.createElement("span");
        span.id = id || __getUuidv4();
        cssClass ? span.classList.add(cssClass) : null;
        __on(span, "click", function (event) {
            chrome.runtime.sendMessage({
                action: "open_edit_for_highlighted_text",
                selectedTextId: event.target.id || null
            });
        });

        return span;
    }

    var __highlightSelectedText = (selectedRange) => {
        highlightSpan = __getHighLightSpan();

        try {
            selectedRange.surroundContents(highlightSpan);
        } catch (e) {

            //console.log(e);
        }
        __showSaveTextPopup(highlightSpan);
        selectedRange = null;
    };

    var __saveSelectedRange = (selectedRange, uuid, cb) => {
        chrome.runtime.sendMessage(
            { action: "save_selected_range", selectedRange: selectedRange, uuid: uuid, done: cb },
            cb);
    };

    function __getUuidv4() {
        return ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, c =>
            (
                c ^
                (crypto.getRandomValues(new Uint8Array(1))[0] & (15 >> (c / 4)))
            ).toString(16)
        );
    }

    function __checkOrigin(origin) {
        origin = origin || window.location.origin;
        var element = document.getElementsByClassName("highlightMenu-arrowClip");
        if (originList.includes(origin) || element.length) {
            return true;
        }

        origin = window.location.origin.split('.');
        if (origin[0] && originList.includes(origin[0])) {
            return true;
        }

        return false;
    }

    function __createSaveTextPopup(leftPosition, topPosition) {
        popupContainer = __createHtml('div');

        var popup = __createHtml('div');
        popup.classList.add('lp-popup');
        var content = __createHtml('div', ['lp-content']);
        var textSapn = __createHtml('span', ["lp-text"], 'lp___save___highlights___text');
        editSpan = __createHtml('span', ['lp-edit-highlight-button'], 'lp___edit___highlights___text');
        buttonSeperator = __createHtml('hr', ['lp-save-popup-button-seperator']);
        textSapn.innerHTML = displayText;
        editSpan.innerHTML = "Notes";
        var iconUrl = __createHtml('a', ['lp-logo-conatiner']);
        iconUrl.href = clientUrl;
        iconUrl.target = "_blank";
        var logo = __createHtml('img', ['lp-logo']);
        logo.src = chrome.extension.getURL("/icons/icon.png");
        popupContainer.style.display = 'none';
        content.appendChild(iconUrl).appendChild(logo);
        content.appendChild(buttonSeperator);
        content.appendChild(editSpan);
        content.appendChild(__createHtml('hr', ['lp-save-popup-button-seperator-two']));
        content.appendChild(textSapn);

        document.body.appendChild(popupContainer).appendChild(popup).appendChild(content);
        __on(editSpan, 'click', function (event) {
            chrome.runtime.sendMessage({ action: "open_edit_highlight", selectedText: selectedText });
        });

        __on(textSapn, 'click', function (event) {
            __saveHighlightedText();
        });

        __on(document.body, 'click', function (event) {
            setTimeout(function () {
                if (!event.target.classList.contains('lp-overlay') && nowPopupIsVisible) {
                    selectedRange = null;
                    popupContainer.style.display = 'none';
                    nowPopupIsVisible = false;
                    selectedText = '';
                    selectedRange = null;
                }
            }, 0);
        });
    }

    function __saveHighlightedText(requestData) {
        chrome.storage.local.get(['lpToken'], (token) => {
            if (token && token.lpToken) {
                var data = {
                    url: window.location.href,
                    selected_text: selectedText
                }

                if (requestData && requestData.message) {
                    data = requestData.message;
                    delete data.action;
                }

                if (highlightSpan) {
                    var higlightPosition = highlightSpan.getBoundingClientRect();
                    var loaderSpan = __createHtml('span');
                    loaderSpan.classList.add('lp-saveing-loader');
                    loaderSpan.innerHTML = 'Saving...';

                    highlightSpan.appendChild(loaderSpan);
                    var spanPosition = loaderSpan.getBoundingClientRect();
                    loaderSpan.style.marginTop = -higlightPosition.height + 'px';
                    loaderSpan.style.marginLeft = (higlightPosition.right - spanPosition.right - spanPosition.width) + 'px';

                    __saveSelectedRange(data, highlightSpan.id, function (response) {
                        loaderSpan.classList.add('lp-saveing-loader-animate');
                    });

                    highlightSpan.classList.add("lp-highlight");
                    popupContainer.style.display = 'none';
                }

                selectedText = '';

            } else {
                __updateSavePopUp('Login');
                chrome.storage.local.get(["lpUserIsAlreadyLoggedIn"], function (storageDetails) {
                    var queryString = "#/register?lporiginsource=extension&islpuser=" + (storageDetails.lpUserIsAlreadyLoggedIn || false);
                    chrome.runtime.sendMessage({ action: "open_window", url: clientUrl + queryString });
                });

            }
        });
    }


    function __showSaveTextPopup(element) {
        var elementPosition = element.getBoundingClientRect();
        var mouseStartPosition = mouseStart.target.getBoundingClientRect();
        var mouseEndPosition = mouseEnd.target.getBoundingClientRect();
        //if (elementPosition && elementPosition.left && elementPosition.width) {
        leftPosition = elementPosition.left;

        if (elementPosition.width) {
            leftPosition = leftPosition + (elementPosition.width / 2) - 57;
        }

        if (elementPosition.left && elementPosition.width) {
            //popupContainer.style.left = leftPosition + 'px';
            //popupContainer.style.top = (topPosition - elementPosition.height - 25) + 'px';
            //popupContainer.style.top = (topPosition - 50) + 'px';
        } else {
            if (mouseStartPosition && mouseEndPosition.width > mouseStartPosition.width) {
                leftPosition = mouseEndPosition.left + (mouseEndPosition.width / 2);
                //popupContainer.style.left = leftPosition + 'px';
            } else {
                leftPosition = mouseStartPosition.left + (mouseStartPosition.width / 2);
                // popupContainer.style.left = leftPosition + 'px';
            }
        }

        popupContainer.style.top = (topPosition - 50) + 'px';
        popupContainer.style.left = leftPosition + 'px';

        if (__checkOrigin(window.location.origin)) {
            // popupContainer.classList.remove('lp-overlay');
            // popupContainer.classList.add('lp-popup-custom');
            popupContainer.style.left = leftPosition + 150 + 'px';
            popupContainer.classList.add('lp-overlay');

        } else {
            popupContainer.classList.add('lp-overlay');
            popupContainer.style.left = leftPosition + 'px';
        }



        popupContainer.style.display = 'none';
        popupContainer.style.display = 'block';
        setTimeout(function () {
            nowPopupIsVisible = true;
        }, 1000);

    }

    chrome.runtime.onMessage.addListener(function (message, sender, sendResponse) {

        if (message.action === 'highlight' && message.selectedTexts && !isUserLoggedIn) {
            try {
                isUserLoggedIn = true;
                allHighlights = message.selectedTexts;
                //Adding +1 to deselect the last selected text on the current website.
                for (var index = 0; index < (message.selectedTexts.length + 1); index++) {
                    if (message.selectedTexts[index] && message.selectedTexts[index].selected_text) {
                        highestTime = (index * 5) + 1;
                        setTimeout(function (highlight) {
                            return function () {
                                var firstSpan = __getHighLightSpan(highlight._id, "lp-highlight");
                                // span.id = __getUuidv4();
                                //span.id = highlight._id || __getUuidv4();
                                if (!window.find(highlight.selected_text)) {
                                    window.find(highlight.selected_text, false, true);
                                }

                                try {
                                    var reHighLightedSelectedRange = window.getSelection().getRangeAt(0);
                                    reHighLightedSelectedRange.surroundContents(firstSpan);
                                } catch (error) {

                                }
                            }
                        }(message.selectedTexts[index]), highestTime);
                    } else {
                        setTimeout(function () {
                            __deselect();
                        }, (index * 5) + 1);
                    }
                }

                if (highlightIdInUrl) {
                    setTimeout(function () {
                        __bringToView(highlightIdInUrl, location.href);
                    }, highestTime + 100);

                }
            } catch (error) {
                // console.log(error);
            }

        }

        if (message.action === "do_focus" && message.id) {
            __bringToView(message.id);
        }

        if (message.action === 'req_auth') {
            __updateSavePopUp('Login');
        }

        if (message.action === 'user_logged_in') {
            __updateSavePopUp(displayText);
        }

        if (message.action === 'check_auth') {
            __setLppocToken();
            chrome.storage.local.get(['lpToken'], (token) => {
                if (token.lpToken) {
                    __updateSavePopUp(displayText);
                } else {
                    __updateSavePopUp("Login");
                }
            });
        }

        if (message.action === 'save_edit_highlighted_text_from_content') {
            __saveHighlightedText(message);
        }

        if (message.action === 'save_highlighted_text_from_context_menu') {
            popupContainer.style.display = 'none';
            __saveHighlightedText(message);
        }

    });

    function __deselect() {
        if (window.getSelection) {
            window.getSelection().removeAllRanges();
        } else if (document.selection) {
            document.selection.empty();
        }
    }

    function __getUrlParmValue(name, url) {
        if (!url) url = location.href;
        name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
        var regexS = "[\\?&]" + name + "=([^&#]*)";
        var regex = new RegExp(regexS);
        var results = regex.exec(url);
        return results == null ? null : results[1];
    }

    function __highlightShouldEnable(event) {
        var stopTags = ["textarea", "input"];
        var editableNode = document.querySelector("[contenteditable=true]");
        var isEditableChild = editableNode ? editableNode.contains(event.target) : false;
        var parentNode = event.target.parentNode;
        var stopTagsInclude = parentNode.tagName ? stopTags.includes(parentNode.tagName.toLocaleLowerCase()) : false;
        if (isEditableChild) {
            return false;
        } else if (stopTagsInclude) {
            return false;
        } else {
            return true;
        }
    }

    function __bringToView(id) {
        var element = document.getElementById(id);
        if (element) {
            var elementPosition = element.getBoundingClientRect();
            if (elementPosition.y && window.scrollBy) {
                window.scrollBy({
                    top: (elementPosition.y - 200),
                    let: 0,
                    behavior: "smooth"
                })
            } else {
                element.scrollIntoView();
            }
        }
    }

    function __createHtml(tagName, classes, id) {
        var element = document.createElement(tagName);
        if (classes) {
            element.className = (classes.join(" "));
        }

        if (id) {
            element.id = id;
        }

        return element;
    }

    function __getStartPosition(event) {
        mouseStart = event;
        isDrag = false;
    }

    function __updateSavePopUp(text) {
        var textId = document.getElementById('lp___save___highlights___text');
        if (text == 'Login') {
            if (popupContainer.childNodes[0]) {
                popupContainer.childNodes[0].style.width = '73px';
                popupContainer.style.width = "73px";
            }

            editSpan.style.display = "none";
            buttonSeperator.style.display = "none";
            var allHighLightClass = document.getElementsByClassName('lp-highlight');
            if (allHighLightClass.length) {
                for (var i = 0; i < allHighLightClass.length; i++) {
                    allHighLightClass[i].className = '';
                }
            }

            if (textId) {
                textId.innerHTML = text;
            }

        } else {
            if (popupContainer.childNodes[0]) {
                popupContainer.childNodes[0].style.width = '137px';
                popupContainer.style.width = "137px";
            }

            if (textId) {
                editSpan.style.display = "";
                buttonSeperator.style.display = "";
                textId.innerHTML = text;
            }
        }
    }

    function __on(element, event, cb) {
        if (element.addEventListener) {
            element.addEventListener(event, cb, false);
        } else if (element.attachEvent) {
            //For IE
            element.attachEvent('on' + event, cb);
        } else {
            console.warn('Add Eventlistener not support by this browser');
        }
    }

    function __setLppocToken(token) {
        var jwtToken = localStorage.getItem('lpWebToken');
        var jwtRefreshToken = localStorage.getItem('lpRefreshWebToken');
        var userLoginStatus = localStorage.getItem('lpUserLoginStatus');

        if (userLoginStatus === "login") {
            chrome.storage.local.set({ 'lpToken': jwtToken }, () => { });
            chrome.storage.local.set({ 'lpRefreshToken': jwtRefreshToken }, () => { });
        }

        if (userLoginStatus === "logout") {
            chrome.storage.local.remove(['lpToken', 'lpRefreshToken', 'lpHighlightCount'], () => { });
        }
    }

    //#Todo: Move to common helper function. 
    function __attr(element, attrName, value) {
        if (element && attrName && value) {
            return element.setAttribute(attrName, value);
        } else if (element, attrName) {
            return element.getAttribute(attrName);
        } else {
            return null;
        }
    }

    function __handleDoubleClicked(event) {
        popupContainer.style.display = 'none';
    }

    function __handleMouseMove(event) {
        isDrag = true;
    }


    __on(window, 'load', function (event) {
        window.onhashchange = function () {
            __setLppocToken();
        }

        __setLppocToken();
        __createSaveTextPopup();
        //__createtextInfoPopup();
        //__createInfoAlert();
        document.querySelector("body").addEventListener("mousedown", __getStartPosition);
        document.querySelector("body").addEventListener("dblclick", __handleDoubleClicked);
        document.querySelector("body").addEventListener("mousemove", __handleMouseMove);
        document.querySelector("body").addEventListener("mouseup", __processSelectedText);
        document.body.setAttribute("lp_chrome_extension", "____lp_chome_extension_install_done_____");
    });

})(window, chrome, console);
